Loading...
Searching...
No Matches
BALL::GAFFTypeProcessor Class Reference

`#include <BALL/MOLMEC/AMBER/GAFFTypeProcessor.h>`

Inheritance diagram for BALL::GAFFTypeProcessor:

## Classes

struct | TypeDefinition
| Nested class definitions. More...
struct | Option
struct | Default

## Public Member Functions

| GAFFTypeProcessor ()
| GAFFTypeProcessor (const Options &new_options)
virtual | ~GAFFTypeProcessor ()
virtual Processor::Result | operator() (Composite &composite)
std::set< String > | getTypeNames () const
Public Member Functions inherited from BALL::UnaryProcessor< Composite >
| UnaryProcessor ()
| UnaryProcessor (const UnaryProcessor &)
virtual | ~UnaryProcessor ()
virtual bool | start ()
virtual bool | finish ()

## Public Attributes

Options | options

## Protected Member Functions

std::vector< TypeDefinition > | getCarbonTypes_ ()
std::vector< TypeDefinition > | getHydrogenTypes_ ()
std::vector< TypeDefinition > | getNitrogenTypes_ ()
std::vector< TypeDefinition > | getOxygenTypes_ ()
std::vector< TypeDefinition > | getSulfurTypes_ ()
void | parseAtomtypeTableFile_ ()
void | precomputeBondProperties_ (Molecule *molecule)
| compute aromaticity, ring memberships, GAFF bond typization, ...
void | precomputeAtomProperties_ (Molecule *molecule)
void | annotateBondTypes_ ()
| Helper for precomputeBondProperties.
void | annotateRingSizes_ ()
| Helper for precomputeAtomProperties.
void | annotateAliphaticAndAromaticRingAtoms_ ()
void | annotatePlanarRingAtoms_ ()
bool | planarAtom_ (const Atom &atom)
bool | assignAtomtype_ (Atom &atom)
void | postProcessAtomTypes_ (Molecule *molecule)

## Protected Attributes

StringHashMap< GAFFCESParser * > | ces_parsers_
std::map< Position, std::vector< TypeDefinition > > | atom_types_
std::vector< std::vector< Atom * > > | sssr_
Molecule * | current_molecule_

## Additional Inherited Members

Public Types inherited from BALL::UnaryFunctor< ArgumentType, ResultType >
typedef ResultType | result_type
typedef ArgumentType | argument_type
typedef ArgumentType & | argument_reference
typedef const ArgumentType & | const_argument_reference
typedef ArgumentType * | argument_pointer
typedef const ArgumentType * | const_argument_pointer

## Detailed Description

Definition at line 37 of file GAFFTypeProcessor.h.

## Constructor & Destructor Documentation

## GAFFTypeProcessor() [1/2]

BALL::GAFFTypeProcessor::GAFFTypeProcessor | ( |  | ) |

## GAFFTypeProcessor() [2/2]

BALL::GAFFTypeProcessor::GAFFTypeProcessor | ( | const Options & | new_options | ) |

## ~GAFFTypeProcessor()

virtual BALL::GAFFTypeProcessor::~GAFFTypeProcessor | ( |  | ) |

virtual

## Member Function Documentation

## annotateAliphaticAndAromaticRingAtoms_()

void BALL::GAFFTypeProcessor::annotateAliphaticAndAromaticRingAtoms_ | ( |  | ) |

protected

## annotateBondTypes_()

void BALL::GAFFTypeProcessor::annotateBondTypes_ | ( |  | ) |

protected

Helper for precomputeBondProperties.

## annotatePlanarRingAtoms_()

void BALL::GAFFTypeProcessor::annotatePlanarRingAtoms_ | ( |  | ) |

protected

## annotateRingSizes_()

void BALL::GAFFTypeProcessor::annotateRingSizes_ | ( |  | ) |

protected

Helper for precomputeAtomProperties.

## assignAtomtype_()

bool BALL::GAFFTypeProcessor::assignAtomtype_ | ( | Atom & | atom | ) |

protected

Check the atom against each possible atom type and try to assign one.

## getCarbonTypes_()

std::vector< TypeDefinition > BALL::GAFFTypeProcessor::getCarbonTypes_ | ( |  | ) |

inline protected

Definition at line 92 of file GAFFTypeProcessor.h.

## getHydrogenTypes_()

std::vector< TypeDefinition > BALL::GAFFTypeProcessor::getHydrogenTypes_ | ( |  | ) |

inline protected

Definition at line 93 of file GAFFTypeProcessor.h.

## getNitrogenTypes_()

std::vector< TypeDefinition > BALL::GAFFTypeProcessor::getNitrogenTypes_ | ( |  | ) |

inline protected

Definition at line 94 of file GAFFTypeProcessor.h.

## getOxygenTypes_()

std::vector< TypeDefinition > BALL::GAFFTypeProcessor::getOxygenTypes_ | ( |  | ) |

inline protected

Definition at line 95 of file GAFFTypeProcessor.h.

## getSulfurTypes_()

std::vector< TypeDefinition > BALL::GAFFTypeProcessor::getSulfurTypes_ | ( |  | ) |

inline protected

Definition at line 96 of file GAFFTypeProcessor.h.

## getTypeNames()

std::set< String > BALL::GAFFTypeProcessor::getTypeNames | ( |  | ) | const

## operator()()

virtual Processor::Result BALL::GAFFTypeProcessor::operator() | ( | Composite & |  | ) |

virtual

operator ()

Reimplemented from BALL::UnaryProcessor< Composite >.

## parseAtomtypeTableFile_()

void BALL::GAFFTypeProcessor::parseAtomtypeTableFile_ | ( |  | ) |

protected

Read file with table of atomtypes and push atomtypes and their TypeDefinition in corresponding vector and store a GAFFCESParser for every CESstring. The path to the atom type file is taken from the value of the option ATOMTYPE_FILENAME.

Exceptions

  BALL::Exception::FileNotFound |

## planarAtom_()

bool BALL::GAFFTypeProcessor::planarAtom_ | ( | const Atom & | atom | ) |

protected

## postProcessAtomTypes_()

void BALL::GAFFTypeProcessor::postProcessAtomTypes_ | ( | Molecule * | molecule | ) |

protected

Postprocessing and cleanup for GAFF types

## precomputeAtomProperties_()

void BALL::GAFFTypeProcessor::precomputeAtomProperties_ | ( | Molecule * | molecule | ) |

protected

Store connectivity, number of attached H-atoms and number of attached N,O,F,Cl and Br-atoms for every atom in molecule

## precomputeBondProperties_()

void BALL::GAFFTypeProcessor::precomputeBondProperties_ | ( | Molecule * | molecule | ) |

protected

compute aromaticity, ring memberships, GAFF bond typization, ...

## Member Data Documentation

## atom_types_

std::map<Position, std::vector<TypeDefinition> > BALL::GAFFTypeProcessor::atom_types_

protected

Definition at line 137 of file GAFFTypeProcessor.h.

## ces_parsers_

StringHashMap<GAFFCESParser*> BALL::GAFFTypeProcessor::ces_parsers_

protected

Definition at line 134 of file GAFFTypeProcessor.h.

## current_molecule_

Molecule* BALL::GAFFTypeProcessor::current_molecule_

protected

Definition at line 143 of file GAFFTypeProcessor.h.

## options

Options BALL::GAFFTypeProcessor::options

Definition at line 88 of file GAFFTypeProcessor.h.

## sssr_

std::vector<std::vector<Atom*> > BALL::GAFFTypeProcessor::sssr_

protected

Definition at line 140 of file GAFFTypeProcessor.h.